// @ts-nocheck
import React, { FC, useEffect } from 'react';
import { Route, Switch, useLocation } from 'wouter';

import { useAuth } from '@prokyon/auth/hook/useAuth';
import { Skeleton } from '@prokyon/components/Skeleton';
import { MenuItem } from '@prokyon/components/Skeleton/types';

import { WelcomePage } from 'pages/WelcomePage';

import { buildRoute, Routes } from './routes';

const topMenu: MenuItem[][] = [
	[
        { label: 'Routa', href: buildRoute('root') },
	],
	[
	],
];

const userMenu: MenuItem[][] = [
	[
        // public
	],
	[
        // authenticated
	],
];

const publicSites: string[] = [];

export const App: FC = () => {
	const { authenticated } = useAuth();

	const [location] = useLocation();

	const isPublicView = !!publicSites.find((url) => location.startsWith(url));
	const isWelcomePage = window.location.pathname === '/';

	if (authenticated === null || authenticated === undefined) {
		return null;
	}

	return (
		<Skeleton
			items={{
				logo: <>$(AppName)</>,
				top: authenticated ? topMenu[1] : isWelcomePage ? [] : topMenu[0],
				user: authenticated ? userMenu[1] : isPublicView ? [] : userMenu[0],
			}}>
			{authenticated ? (
				<Switch>
					<Route>404!</Route>
				</Switch>
			) : (
				<Switch>
					<Route path={Routes.root} component={WelcomePage} />
					<Route>404!</Route>
				</Switch>
			)}
		</Skeleton>
	);
};
